/*
-02/23/2006: Petre M.
  -this file contains the extern declarations used throughout the program

*/

#include "structures.h"
#include "system_def.h"


#define Bit0 0x01
#define Bit1 0x02
#define Bit2 0x04
#define Bit3 0x08
#define Bit4 0x10
#define Bit5 0x20
#define Bit6 0x40
#define Bit7 0x80

#define NBit0 0xfe
#define NBit1 0xfd
#define NBit2 0xfb
#define NBit3 0xf7
#define NBit4 0xef
#define NBit5 0xdf
#define NBit6 0xbf
#define NBit7 0x7f

#define Nr_Bytes_1 1
#define Nr_Bytes_2 2
#define Nr_Bytes_3 3
#define Nr_Bytes_4 4
#define Nr_Bytes_5 5

#define Blink_1Hz 0
#define Blink_500mHz 1
#define Blink_333mHz 2
#define Blink_250mHz 3

#define End_Byte_7 0x55
#define End_Byte_8 0xaa
#define End_Byte_9 0x55
#define End_Byte_10 0xaa

#define WD_15_6msec 0
#define WD_31_2msec 1
#define WD_62_5msec 2
#define WD_125msec  3
#define WD_250msec  4
#define WD_500msec  5
#define WD_1sec     6
#define WD_2sec     7


//these definitions are used in lcd.c to introduce the desired number of fractional digits
#define Fract_Digits_0 0
#define Fract_Digits_1 1
#define Fract_Digits_2 2
#define Fract_Digits_3 3
#define Fract_Digits_4 4

  extern char const code Project_Name[16];
  extern char const code Project_Vers[16];
  extern char const code Project_Date[12];
  extern char const code Project_Time[9];
  extern char const code Project_Misc[11];


  extern struct Date_struct idata Date;
  extern struct Five_Bytes_struct data Active_Energy;

  extern int idata I_1A_threshold;
  extern int idata V_1V_threshold;


  extern char idata Low_Priority_Command[1];
  extern char idata LCD_Command[1];
  extern char idata Command_Status[1];

  extern char idata N;
  extern int idata X;
  extern idata unsigned char idata  *I2C_ptr;
  extern char idata I2C_Status;
  extern struct Five_Bytes_struct idata Reactive_Energy, Apparent_Energy;
  extern char idata LCD_buffer[15];
  extern char const code Digit_Table[10];


  extern char const code Months[12];
  extern unsigned char idata Meter_Errors[1];


  extern unsigned char idata Fault_Days;
  extern char idata LCD_Digits[9];
  extern unsigned char idata CF2_Frac, New_CF2_Counter;

  extern char data Temporary[8], Temporary1[8];

  extern char const code Default_Ac_Energy[5];
  extern char const code Default_Re_Energy[5];
  extern char const code Default_Ap_Energy[5];
  extern char const code Default_Date[4];
  extern unsigned char const code Default_Fault_Days;

  extern unsigned char idata UART_Rx[11];
  extern idata unsigned char idata *UART_ptr;
  extern void (* idata UART_func_ptr)(void);
  extern int const code Table_UART[];
  extern int const code Table_LCD[5];
  extern signed char idata LP_Task;
  extern int const code Table_LP_Func[8];

  extern char idata Temporary_ISR[3];

  extern void I2C_Do_nothing(void);
  extern void Rx_CTRL_byte(void);
  extern void Rx_byte(void);
  extern void Tx_page(char Nr_Bytes, int EEPROM_address,unsigned char idata  *Pointer);
  extern void Tx_CTRL_byte(char Nr_Bytes, int EEPROM_address,unsigned char idata  *Pointer);
  extern void Tx_byte(char Nr_Bytes, int EEPROM_address,unsigned char idata  *Pointer);
  extern void Tx_page2(void);
  extern void Setup_LCD(void);

  extern void Setup_LCD_PSM1(void);
  extern void Display_to_LCD(void);
  extern void Irms_threshold_read(void);
  extern void Vrms_threshold_read(void);

  extern void Blink_LCD(char BLKFREQ);
  extern void Setup_Watchdog(char PRE);
  extern void Refresh_Watchdog(void);
  extern void Clear_flag(char NBit, char idata  *iram_ptr);
  extern void Clear_2_flags(char NBit_1, char idata  *iram_ptr1,char NBit_2,
                            char idata  *iram_ptr2 );
  extern void Set_flag(char Bit, char idata  *iram_ptr);

  extern void Manage_Numbers(char Nr_Fract_Digits);
  extern void Manage_Time(void);
  extern void Manage_Display(void);
  extern void Decide_LCD_command(void);
  extern void Setup_Ext_Int(void);
  extern void INT0_Interrupt(void);
  extern void Manage_LCD_commands(void);
  extern void Active_Energy_Display(void);
  extern void IRMS_Display(void);
  extern void VRMS_Display(void);
  extern void Date_Display(void);
  extern void Display_Time_Date(char idata *iram_ptr1);

  extern void Store_time(char idata *ptr);
  extern void Calendar_write(void);
  extern void Calendar_read(void);
  extern void ADE_Interrupt(void);
  extern void Reload_Energy(void);
  extern void Setup_Energy(void);
  extern void Accumulate_Energy(void);
  extern void Reload_from_EEPROM(void);
  extern void Active_Energy_read(void);
  extern void Active_Energy_write(void);
  extern void Tx_High_Importance(char Nr_Bytes, int EEPROM_address,unsigned char idata  *Pointer);
  extern void Tx_Low_Importance(char Nr_Bytes, int EEPROM_address,unsigned char idata  *Pointer);
  extern void Disable_Watchdog(void);
  extern void Meter_Calibration(void);
  extern void Write_ADE_SFR(char ByteM, char ByteL, char Register);
  extern void Read_ADE_SFR(unsigned char idata *Pointer, char Register);

  extern void End_message_bytes(char a, char b, char c, char d);
  extern void End_Low_Priority_Tasks(void);

  extern void Bin2bcd(void);
  extern void Display_Number(char Nr_Fract_Digits, unsigned int unit_ratio);
  extern void Comp_Nibbles(void);
  extern void Comp_Nibbles2(char data *, char data *);
  extern void mult24x16(void);

  extern void Wait_loop(void);

  extern void Disable_Pull_Ups(void);
  extern void Enable_Pull_Ups(void);
  extern void Monthly_Energy_Storage(void);
  extern void Midnight_Management(void);
  extern void Battery_Alarm(void);
  extern void Setup_Power_PSM0(void);



